﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sz
{
    internal class SeverZapad
    {
        double[][] arrayTarif;
        int[][] arrayDelivery;
        int[] suppliers, customers;
        double targetFunction;

        public SeverZapad(double[][] arrayTarif, int[][]suppliersAndCustomers)
        {
            this.arrayTarif = arrayTarif;
            arrayDelivery = new int[arrayTarif.Count()][];
            for (int i = 0; i < arrayTarif.Count(); i++)
                arrayDelivery[i] = new int[arrayTarif[i].Count()];
            suppliers = suppliersAndCustomers[0];
            customers = suppliersAndCustomers[1];
        }

        void TargetFunction()
        {
            for (int i = 0; i < arrayDelivery.Count(); i++)
            {
                for (int j = 0; j < arrayDelivery[i].Count(); j++)
                {
                    targetFunction += arrayDelivery[i][j] * arrayTarif[i][j];
                }
            }
        }

        public void RealizationAlg()
        {
            int i = 0, j = 0;
            int delivery;
            while (i < suppliers.Length & j < customers.Length)
            {
                delivery = Math.Min(suppliers[i], customers[j]);
                suppliers[i] -= delivery;
                customers[j] -= delivery;
                arrayDelivery[i][j] = delivery;
                if (suppliers[i] == 0) i++;
                if(customers[j] == 0) j++;
            }
            TargetFunction();
        }

        public override string ToString()
        {
            string optPlan = string.Empty;
            foreach (int[] line in arrayDelivery)
            {
                foreach (int item in line)
                    optPlan += $"{item} ";
                optPlan += "\n";
            }

            return $"{optPlan}\n{targetFunction}";
        }
    }
}
